searchNodes=[{"doc":"ExCmd is an Elixir library to run and communicate with external programs with back-pressure.","ref":"ExCmd.html","title":"ExCmd","type":"module"},{"doc":"Runs the given command with arguments and return an Enumerable to read command output. First parameter must be a list containing command with arguments. example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options input - Input can be either an Enumerable or a function which accepts Collectable . Enumerable: # list ExCmd . stream! ( ~w(base64) , input : [ &quot;hello&quot; , &quot;world&quot; ] ) |&gt; Enum . to_list ( ) # stream ExCmd . stream! ( ~w(cat) , input : File . stream! ( &quot;log.txt&quot; , [ ] , 65536 ) ) |&gt; Enum . to_list ( ) Collectable: If the input in a function with arity 1, ExCmd will call that function with a Collectable as the argument. The function must push input to this collectable. Return value of the function is ignored. ExCmd . stream! ( ~w(cat) , input : fn sink -&gt; Enum . into ( 1 .. 100 , sink , &amp; to_string / 1 ) end ) |&gt; Enum . to_list ( ) By defaults no input is given exit_timeout - Duration to wait for external program to exit after completion before raising an error. Defaults to :infinity All other options are passed to ExCmd.Process.start_link/2 Example ExCmd . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65336 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( )","ref":"ExCmd.html#stream!/2","title":"ExCmd.stream!/2","type":"function"},{"doc":"","ref":"ExCmd.html#t:collectable_func/0","title":"ExCmd.collectable_func/0","type":"type"},{"doc":"Server to interact with external process ExCmd.stream! should be preferred over this. Use this only if you need more control over the life-cycle of IO streams and OS process.","ref":"ExCmd.Process.html","title":"ExCmd.Process","type":"module"},{"doc":"Waits for the program to terminate. If the program terminates before timeout, it returns {:ok, exit_status} else returns :timeout","ref":"ExCmd.Process.html#await_exit/2","title":"ExCmd.Process.await_exit/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExCmd.Process.html#child_spec/1","title":"ExCmd.Process.child_spec/1","type":"function"},{"doc":"Closes input stream. Which signal EOF to the program","ref":"ExCmd.Process.html#close_stdin/1","title":"ExCmd.Process.close_stdin/1","type":"function"},{"doc":"Returns os pid of the command","ref":"ExCmd.Process.html#os_pid/1","title":"ExCmd.Process.os_pid/1","type":"function"},{"doc":"Returns port_info","ref":"ExCmd.Process.html#port_info/1","title":"ExCmd.Process.port_info/1","type":"function"},{"doc":"Return bytes written by the program to output stream. This blocks until the programs write and flush the output","ref":"ExCmd.Process.html#read/2","title":"ExCmd.Process.read/2","type":"function"},{"doc":"Starts a process using cmd_with_args and with options opts cmd_with_args must be a list containing command with arguments. example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options cd - the directory to run the command in env - a list of tuples containing environment key-value. These can be accessed in the external program log - When set to true odu logs and command stderr output are logged. Defaults to false","ref":"ExCmd.Process.html#start_link/2","title":"ExCmd.Process.start_link/2","type":"function"},{"doc":"Returns status of the process. It will be either of :started , {:done, exit_status}","ref":"ExCmd.Process.html#status/1","title":"ExCmd.Process.status/1","type":"function"},{"doc":"Kills the program","ref":"ExCmd.Process.html#stop/1","title":"ExCmd.Process.stop/1","type":"function"},{"doc":"Writes iodata data to programs input streams This blocks when the pipe is full","ref":"ExCmd.Process.html#write/3","title":"ExCmd.Process.write/3","type":"function"},{"doc":"Defines a ExCmd.Stream struct returned by ExCmd.stream!/2 .","ref":"ExCmd.Stream.html","title":"ExCmd.Stream","type":"module"},{"doc":"","ref":"ExCmd.Stream.html#t:t/0","title":"ExCmd.Stream.t/0","type":"type"},{"doc":"","ref":"ExCmd.Process.Error.html","title":"ExCmd.Process.Error","type":"exception"},{"doc":"ExCmd is an Elixir library to run and communicate with external programs with back-pressure mechanism. It makes use os provided stdio buffer for this. Communication with external program using Port is not demand driven. So it is easy to run into memory issues when the size of the data we are writing or reading from the external program is large. ExCmd tries to solve this problem by making better use of os provided stdio buffers and providing demand-driven interface to write and read from external program. It can be used to stream data through an external program. For example, streaming a video through ffmpeg to serve a web request. Getting audio out of a video stream is as simple as ExCmd . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65336 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( ) Major Features Unlike beam ports, ExCmd puts back pressure on the external program Stream abstraction No separate shim installation required Ships pre-built binaries for MacOS, Windows, Linux Proper program termination. No more zombie process Ability to close stdin and wait for output (with ports one can not selectively close stdin) If you are not interested in streaming capability, ExCmd can still be useful because of the features listed above. For example running command and getting output as a string ExCmd . stream! ( ~w(curl ifconfig.co) ) |&gt; Enum . into ( &quot;&quot; ) If you want to use shell to handle more complex pipelines and globs, you can just spawn shell process and pass your shell command as the argument cmd = &quot;echo &#39;foo baar&#39; | base64&quot; ExCmd . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , cmd ] ) |&gt; Enum . into ( &quot;&quot; ) Refer documentation for information Check out Exile which is an alternative solution based on NIF without middleware overhead","ref":"readme.html","title":"ExCmd","type":"extras"},{"doc":"def deps do [ { :ex_cmd , &quot;~&gt; x.x.x&quot; } ] end","ref":"readme.html#installation","title":"ExCmd - Installation","type":"extras"},{"doc":"MIT License Copyright (c) 2020 Akash Hiremath Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]